<?php
// 应用公共文件
use app\BusinessException;
use think\response\Json;

/**
 * 成功返回
 *
 * @param mixed $data 成功数据
 * @param string $msg 成功提示
 * @param integer $code 成功码
 *
 * @return json
 */
function success($data = [], string $msg = '操作成功', int $code = 1): Json
{
    $res['code'] = $code;
    $res['msg'] = $msg;
    $res['data'] = $data;

    return json($res);
}

/**
 * 错误返回
 *
 * @param mixed $data 成功数据
 * @param string $msg 成功提示
 * @param integer $code 成功码
 *
 * @return json
 */
function error($data = [], string $msg = '操作失败', int $code = 0): Json
{
    $res['code'] = $code;
    $res['msg'] = $msg;
    $res['data'] = $data;

    return json($res);
}

/**
 * 抛出异常
 *
 * @param string $msg 异常提示
 * @param integer $code 错误码
 *
 * @return void
 * @throws BusinessException
 */
function exception(string $msg = '操作失败', int $code = 0)
{
    throw new BusinessException($msg, $code);
}

/**
 * 兼容排序字段
 * @param $order
 * @param $default
 * @return array|mixed
 */
function changeSort($order, $default)
{
    if (empty($order)) {
        return $default;
    }
    else {
        $tmp = [];
        foreach ($order as $key => $it) {
            if (in_array($it, ['ascend', 'descend', 'asc', 'desc'])) {
                $tmp[$key] = $it == 'descend' ? 'desc' : 'asc';
            }
        }
        return $tmp;
    }
}
