<?php

namespace app\controller;

use app\model\AuthLogModel;
use app\service\AuthService;
use app\service\TokenService;
use app\service\UserService;
use app\BusinessException;
use think\db\exception\DbException;
use think\facade\Request;
use think\response\Json;

class Auth extends Base
{
    /**
     * 登录
     * @throws DbException|BusinessException
     */
    public function login(): Json
    {
        $param['account'] = Request::param('account/s', '');
        $param['password'] = Request::param('password/s', '');

        $user = AuthService::login($param);
        if ($user['disable_switch'] == 1) exception('用户已禁用');
        $result['user_id'] = $user['user_id'];
        $tmp = TokenService::create($user);;
        $result['token'] = $tmp['token'];
        $result['resource_token'] = $tmp['resource_token'];
        return success($result);
    }

    /**
     * 登出
     * @throws DbException|BusinessException
     */
    public function logout(): Json
    {
        $user = UserService::current();
        if (!empty($user)) {
            AuthLogModel::where('user_id', $user['user_id'])->save(['status' => 2]);
        }
        return success([], '登出成功');
    }
}
