<?php

namespace app\validate;

use app\model\UploadTaskChunkModel;
use app\model\UploadTaskModel;
use think\db\exception\DbException;
use think\Validate;

class UploadTaskChunkValidate extends Validate
{
    protected $rule = [
        'utc_id' => ['require'],
        'ut_id' => ['require', 'checkUploadTaskId'],
        'chunk' => ['require', 'emptyChunk'],
        'start' => ['require'],
        'end' => ['require'],
        'md5' => ['require'],
    ];

    protected $message = [];

    protected $scene = [
        'add' => ['ut_id', 'chunk', 'start', 'end', 'md5',],
    ];

    /**
     * @param $value
     * @param $rule
     * @param $data
     * @return bool
     * @throws DbException
     */
    protected function checkUploadTaskId($value, $rule, $data = []): bool
    {
        $uploadTask = UploadTaskModel::where('ut_id', $value)->find();
        return !empty($uploadTask);
    }

    /**
     * @param $value
     * @param $rule
     * @param $data
     * @return bool
     * @throws DbException
     */
    protected function emptyChunk($value, $rule, $data = []): bool
    {
        $uploadTask = UploadTaskChunkModel::where('ut_id', $data['ut_id'])
            ->where('chunk', $value)->find();
        return empty($uploadTask);
    }
}