<?php

namespace app\validate;

use app\model\UploadTaskModel;
use think\Validate;

class UploadTaskValidate extends Validate
{
    protected $rule = [
        'ut_id' => ['require', 'checkUploadTaskId'],
        'name' => ['require'],
        'size' => ['require'],
        'chunks' => ['require'],
        'md5' => ['require'],
        'ext' => ['require'],
    ];

    protected $message = [];

    protected $scene = [
        'add' => ['name', 'size', 'chunks', 'md5', 'ext',],
        'merge' => ['ut_id',],
    ];

    protected function checkUploadTaskId($value, $rule, $data = []): bool
    {
        $uploadTask = UploadTaskModel::where('ut_id', $value)->find();
        return !empty($uploadTask);
    }
}